#ifndef NN_STATISTICS_H
#define NN_STATISTICS_H

#include <string>

#include "NN.h"

class NN_statistics
{
public:

    enum NN_type {PSO_CPU, PSO_OpenCL_private_GPU, PSO_OpenCL_private_CPU, PSO_OpenCL_local_GPU, PSO_OpenCL_local_CPU, BP_CPU, BP_OpenCL_GPU, BP_OpenCL_CPU};

    // Times numIterations iterations of the nn_type network and writes the averages to outputFile. Timings are made for for sample sizes from start to end for the given increments.
    static void NN_sample_size_timings(NN_type nn_type, int start, int increment, int end, std::string outputFile, int numIterations,
                                       std::string nnetConfigFile, std::string trainingDataFile, std::string algorithmConfigFile);

    // There is one hidden layer and it's neurons are changed from start to end with the given increment and timed.
    static void NN_num_neurons_in_layer_timings(NN_type nn_type, int start, int increment, int end, std::string outputFile, int numIterations,
                                       int numInputs, int numOutputs, std::string trainingDataFile, std::string algorithmConfigFile, int numSamples, int numHiddenLayers=1);

    // How many hidden layers are there. Each one is the given size.
    static void NN_num_layers_timings(NN_type nn_type, int start, int increment, int end, int neuronsInLayer, std::string outputFile, int numIterations,
                                       int numInputs, int numOutputs, std::string trainingDataFile, std::string algorithmConfigFile, int numSamples);

    // Makes one run for each samples file with the fileNameExtension.
    static void Job_Scheduling_statistics(std::string fileNameExtension,std::string nnetConfigFile, std::string psoConfigFile);

    static NN *create_NN_based_on_type_enum(NN_type nn_type, std::string nnetConfigFile, std::string trainingDataFile, std::string algorithmConfigFile);
    static void destroy_NN_based_on_type_enum(NN_type nn_type, NN *nn); // it's an abomination
};



#endif // NN_STATISTICS_H
